Summary:        LLVM to SPIRV Translator
Name:           spirv-llvm-translator
Version:        16.0.0
Release:        2%{?dist}
License:        NCSA
URL:            https://github.com/KhronosGroup/SPIRV-LLVM-Translator
Source0:        %{url}/archive/v%{version}/%{name}-%{version}.tar.gz

Patch0001:      0001-Update-spirv-as-invocations-1934.patch
Patch0002:      0002-Rename-ConvertFToTF32INTEL-to-RoundFToTF32INTEL-1913.patch
Patch0003:      0003-Fix-standalone-builds-with-LLVM_LINK_LLVM_DYLIB-ON-1.patch
Patch0004:      0004-Fix-relationals-builtin-translation-bug.patch
Patch0005:      0005-Use-fp_fast_mode-extension-with-the-capability-2028.patch
Patch0006:      0006-Backport-to-16-Fix-SPIRV-Friendly-IR-mangling-for-op.patch
Patch0007:      0007-Backport-to-16-Split-JointMatrixMadINTEL-instruction.patch
Patch0008:      0008-Backport-to-16-Workaround-unsupported-freeze-insn-20.patch
Patch0009:      0009-Backport-to-16-OpaquePointers-Adjust-builtin-variabl.patch

BuildRequires:  gcc gcc-c++ cmake ninja-build llvm-devel llvm-static
BuildRequires:  spirv-headers-devel spirv-tools-devel zlib-devel

%description
Khronos LLVM to SPIRV Translator. This is a library
to be used by Mesa for OpenCL support. It translate
LLVM IR to Khronos SPIR-V. It also includes a
standalone tool used for building libclc.

%package devel
Summary: Development files for LLVM to SPIRV Translator
Requires: %{name} = %{version}-%{release}

%description devel
This package contains libraries and header files for
developing against %{name}

%package tools
Summary: Standalone llvm to spirv translator tool
Requires: %{name} = %{version}-%{release}

%description tools
This package contains the standalone llvm to spirv tool.

%prep
%autosetup -n SPIRV-LLVM-Translator-%{version} -p1

%build
%cmake -GNinja \
       -DLLVM_BUILD_TOOLS=ON \
       -DCMAKE_BUILD_TYPE=RelWithDebInfo \
       -DCMAKE_INSTALL_RPATH:BOOL=";" \
       -DLLVM_DIR="/usr/lib64/cmake/llvm/" \
       -DLLVM_LIBDIR_SUFFIX=64 \
       -DLLVM_EXTERNAL_PROJECTS="SPIRV-Headers" \
       -DLLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR="/usr/include/spirv/"

%cmake_build

%install
%cmake_install

%files
%doc README.md
%{_libdir}/libLLVMSPIRVLib.so.*

%files tools
%{_bindir}/llvm-spirv

%files devel
%dir %{_includedir}/LLVMSPIRVLib/
%{_includedir}/LLVMSPIRVLib/
%{_libdir}/libLLVMSPIRVLib.so
%{_libdir}/pkgconfig/LLVMSPIRVLib.pc

%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 16.0.0-2
- Rebuilt for OpenCloudOS Stream 23.09

* Thu Sep 07 2023 kianli <kianli@tencent.com> - 16.0.0-1
- Initial build
